<!-- <!DOCTYPE html> -->

<launch>

<!--_________________________________________________________________-->
<!--__________________ PARAMETERS ___________________________________-->
<!--_________________________________________________________________-->

  <arg name="world_id" default="/optitrak"/>
  <arg name="robot_id" default="/kinton"/>
  <arg name="robot_base" default="$(arg robot_id)/base_link"/>


  <!-- Simulation -->
  <arg name="kinton_"              default="False" />
  <arg name="kinton_cameras_"      default="False"/>
  <arg name="kinton_arm_unina_"    default="False"/>
  <arg name="kinton_arm_catec_"    default="False"/>
  <arg name="kinton_arm_iri_"      default="True"/>

  <!-- ******** Target *********************-->
 	
  <!-- ******** Target 1 -->
  <arg name="desired_x"           default="0.0"/>
  <arg name="desired_y"           default="0.0"/>
  <arg name="desired_z"           default="1.0"/>
  <arg name="desired_roll"        default="0.0"/>
  <arg name="desired_pitch"       default="0.0"/>
  <arg name="desired_yaw"         default="0.0"/>  
  <!-- ******** Target 2 -->
  <arg name="desired2_x"          default="0.0"/>
  <arg name="desired2_y"          default="0.0"/>
  <arg name="desired2_z"          default="1.5"/>
  <arg name="desired2_roll"       default="0.0"/>
  <arg name="desired2_pitch"      default="0.0"/>
  <arg name="desired2_yaw"        default="0.0"/>
  
  <!-- ******** Initial position ***********-->
  <arg name="quad_x_ini_"         default="-1.0"/>
  <arg name="quad_y_ini_"         default="0.0"/>
  <arg name="quad_z_ini_"         default="0.25"/>
  <arg name="quad_R_ini_"         default="0.0"/>
  <arg name="quad_P_ini_"         default="0.0"/>
  <arg name="quad_Y_ini_"         default="0.0"/>
  <arg name="arm_q1_ini_"         default="0.0"/>
  <arg name="arm_q2_ini_"         default="0.0"/>
  <arg name="arm_q3_ini_"         default="0.0"/>
  <arg name="arm_q4_ini_"         default="0.0"/>
  <arg name="arm_q5_ini_"         default="0.0"/>
  <arg name="arm_q6_ini_"         default="0.0"/>

  <!-- ******** Task ***********************-->
  <!-- Primary task (Gain Matrix) -->
  <arg name="W_alpha_min_"        default="0.2"/>
  <arg name="W_min_"              default="0.05"/>
  <arg name="W_max_"              default="4.0"/>
  
  <!-- Security Measure, Ground distance -->
  <arg name="Inf_radius_"        default="0.5"/>

  <!-- Other tasks -->
  <arg name="enable_sec_task_"       default="False"/>
  <arg name="gain_sec_task_CoG_"     default="1.0"/>
  <arg name="gain_sec_task_jntlim_"  default="0.2"/> 

  <!-- Third task (Desired arm joint positions) -->
  <arg name="third_task_q1_"        default="0.0"/>
  <arg name="third_task_q2_"        default="-0.4"/>
  <arg name="third_task_q3_"        default="1.0"/>
  <arg name="third_task_q4_"        default="1.45"/>
  <arg name="third_task_q5_"        default="0.0"/>
  	
  <!-- ******** Robot joints saturations (m/s and rad/s) ******** -->
  <arg name="sat_enable_"          default="False"/>
  <arg name="sat_quad_linear_"     default="0.1"/>
  <arg name="sat_quad_angular_"    default="0.2"/>
  <arg name="sat_arm_joint_vel_"   default="0.2"/>
  
  <!-- ******** Write files with data to local disk ******** -->
  <arg name="write_files_"         default="False"/>
  <arg name="folder_name_"         default="/experiments/results"/>

  <!-- ******** Activation ***************** -->
  <arg name="activate"            default="True"/>

<!--_________________________________________________________________-->
<!--_____________________ NODES _____________________________________-->
<!--_________________________________________________________________-->

<!-- ____________ Spawn QUADROTOR ________________-->
<include file="$(find kinton_bringup)/launch/cam/bluefox/cam.launch">
    <arg name="cam1_name" value="/kinton/arm_cam"/>
    <arg name="cam1_frame" value="/kinton/arm_cam_optical_frame"/>
</include>

<!-- ___________ ARM ___________-->
<!--<node pkg="kinton_arm_node" type="kinton_arm_node" name="kinton_arm_node" output="screen">
  <param name="serial_port" type="string" value="/dev/ttyACM0"/>
  <param name="baudrate" type="int" value="115200"/>  
  <param name="dev_id" type="int" value="10"/>  
  <param name="velocity" type="int" value="5"/> 
  <remap from="~joint_traj" to="/$(arg robot_id)/joint_traj"/>
  <remap from="~arm_joint_feedback" to="/$(arg robot_id)/joint_states"/>
</node>
-->
<!-- _______________ AR_pose _____________________-->
<!--<node name="ar_pose" pkg="ar_pose" type="ar_multi" respawn="false">
  <param name="marker_pattern_list" type="string" value="$(find kinton_arm_task_priority_control)/launch/params/object_4x4"/>
  <param name="threshold" type="int" value="50"/>
  <remap from="/camera/image_raw"    to="/kinton/arm_cam/image_raw"/>
  <remap from="/camera/camera_info"  to="/kinton/arm_cam/camera_info"/>
</node>
-->

<!-- _______________ ARUCO __________________-->
<!--<include file="$(find kinton_arm_task_priority_control)/launch/kinton_aruco_to_armarker.launch">
  <arg name="image_name" value="/$(arg robot_id)/arm_cam/image_raw"/>
  <arg name="camera_info_name" value="/$(arg robot_id)/arm_cam/camera_info"/>
  <arg name="camera_optical_frame" value="$(arg robot_id)/arm_cam_optical_frame"/>
</include>
-->
<!-- _________ OPTITRACK AS OBJECT DETECTOR ______-->
<include file="$(find transf_to_armarker_msg)/launch/transf_to_armarker_msg.launch"/>

<!-- _________ Target Selector _____________-->
<include file="$(find kinton_tag_selector)/launch/kinton_tag_selector.launch">
  <arg name="target_name" value="/iri_artag_ibvs/target"/>
</include>  

<!-- _________ iri Visual Servo _______-->
<include file="$(find iri_artag_ibvs)/launch/iri_artag_ibvs.launch">
  <arg name="topic_name" value="/kinton_tag_selector/output_tag"/>
  <arg name="img_width" value="752"/>
  <arg name="img_height" value="480"/>    
  <arg name="xp" value="0.05"/>
   <arg name="xi" value="0.0"/>
    <arg name="xd" value="0.0"/>
  <arg name="yp" value="0.05"/>
   <arg name="yi" value="0.0"/>
    <arg name="yd" value="0.0"/>
  <arg name="zp" value="0.05"/>
   <arg name="zi" value="0.0"/>
    <arg name="zd" value="0.0"/>
  <arg name="Rp" value="0.05"/>
   <arg name="Ri" value="0.0"/>
    <arg name="Rd" value="0.0"/>
  <arg name="Pp" value="0.05"/>
   <arg name="Pi" value="0.0"/>
    <arg name="Pd" value="0.0"/>
  <arg name="Yp" value="0.05"/>
   <arg name="Yi" value="0.0"/>
    <arg name="Yd" value="0.0"/>  
  <arg name="i_limit" value="0.1"/> 
  <arg name="write_files" value="$(arg write_files_)"/>
  <arg name="folder_name" value="$(arg folder_name_)/ibvs"/>
</include>

<!-- _________  Kinton Autonomy ______-->
<!--<node pkg="kinton_autonomy" type="kinton_autonomy" name="kinton_autonomy" output="screen">
  <remap from="~pose" to="$(arg robot_id)/pose"/>
  <remap from="~motor_control" to="fcu/motor_control"/>
  <remap from="~status" to="fcu/status"/>
  <remap from="~stop_ctrl" to="/kinton_wp_ctrl/stop_ctrl"/>
  <remap from="~stop_plan" to="/kinton_wp_plan/stop_plan"/>
  <remap from="/waypoints/goal" to="/kinton_wp_ctrl/waypoints/goal"/>
  <remap from="/waypoints/feedback" to="/kinton_wp_ctrl/waypoints/feedback"/>
  <remap from="/waypoints/result" to="/kinton_wp_ctrl/waypoints/result"/>
  <remap from="/waypoints/cancel" to="/kinton_wp_ctrl/waypoints/cancel"/>
  <remap from="/waypoints/status" to="/kinton_wp_ctrl/waypoints/status"/>
  <remap from="/land/goal" to="/kinton_wp_ctrl/land/goal"/>
  <remap from="/land/feedback" to="/kinton_wp_ctrl/land/feedback"/>
  <remap from="/land/result" to="/kinton_wp_ctrl/land/result"/>
  <remap from="/land/cancel" to="/kinton_wp_ctrl/land/cancel"/>
  <remap from="/land/status" to="/kinton_wp_ctrl/land/status"/>
  <param name="use_tf" type="bool" value="false"/>
  <param name="world_frame_id" type="string" value="$(arg world_id)"/>
  <param name="robot_frame_id" type="string" value="$(arg robot_id)"/>
</node>
-->
<!-- _________  Kinton WP Control ______-->
<!--<node pkg="kinton_wp_ctrl" type="kinton_wp_ctrl" name="kinton_wp_ctrl" output="screen">
  <remap from="~pose" to="/kinton/pose"/>  
  <remap from="~/control" to="/fcu/control"/>
  <param name="use_tf" type="bool" value="false"/>
  <param name="world_frame_id" type="string" value="/optitrak"/>
  <param name="robot_frame_id" type="string" value="/kinton"/>
  <param name="kp_x" type="double" value="0.2"/> 
  <param name="ki_x" type="double" value="0.7"/> 
  <param name="kd_x" type="double" value="0.0"/> 
  <param name="kp_y" type="double" value="0.2"/> 
  <param name="ki_y" type="double" value="0.7"/> 
  <param name="kd_y" type="double" value="0.0"/> 
  <param name="kp_z" type="double" value="0.2"/> 
  <param name="ki_z" type="double" value="0.7"/> 
  <param name="kd_z" type="double" value="0.0"/> 
  <param name="kp_yaw" type="double" value="0.2"/> 
  <param name="ki_yaw" type="double" value="0.7"/> 
  <param name="kd_yaw" type="double" value="0.0"/> 
  <param name="i_lim" type="double" value="0.1"/> 
  <param name="trimm_x" type="double" value="0.0"/> 
  <param name="trimm_y" type="double" value="0.0"/>
  <param name="rollpitch_sat_min" type="double" value="-0.146"/>
  <param name="rollpitch_sat_max" type="double" value="0.146"/>
  <param name="yaw_sat_min" type="double" value="-1.0"/>
  <param name="yaw_sat_max" type="double" value="1.0"/>
  <param name="thrust_ctrl_ref" type="double" value="0.47"/>
  <param name="thrust_sat_max" type="double" value="0.55"/>
  <param name="thrust_sat_min" type="double" value="0.35"/>
</node>
-->

<!-- _________  Kinton Experiment planner ______-->
<!--<node pkg="kinton_wp_plan" type="kinton_wp_plan" name="kinton_wp_plan" output="screen">
  <param name="plan_file_name" type="string" value="$(find kinton_arm_task_priority_control)/launch/params/sim_exp_plan.xml"/>
  <remap from="/take_off/goal" to="/kinton_autonomy/input_take_off/goal"/>
  <remap from="/take_off/feedback" to="/kinton_autonomy/input_take_off/feedback"/>
  <remap from="/take_off/result" to="/kinton_autonomy/input_take_off/result"/>
  <remap from="/take_off/cancel" to="/kinton_autonomy/input_take_off/cancel"/>
  <remap from="/take_off/status" to="/kinton_autonomy/input_take_off/status"/>
  <remap from="/land/goal" to="/kinton_autonomy/input_land/goal"/>
  <remap from="/land/feedback" to="/kinton_autonomy/input_land/feedback"/>
  <remap from="/land/result" to="/kinton_autonomy/input_land/result"/>
  <remap from="/land/cancel" to="/kinton_autonomy/input_land/cancel"/>
  <remap from="/land/status" to="/kinton_autonomy/input_land/status"/>  
  <remap from="/waypoints/goal" to="/kinton_autonomy/input_waypoints/goal"/>
  <remap from="/waypoints/feedback" to="/kinton_autonomy/input_waypoints/feedback"/>
  <remap from="/waypoints/result" to="/kinton_autonomy/input_waypoints/result"/>
  <remap from="/waypoints/cancel" to="/kinton_autonomy/input_waypoints/cancel"/>
  <remap from="/waypoints/status" to="/kinton_autonomy/input_waypoints/status"/>  
  <remap from="/tags/goal" to="/kinton_tag_selector/tagseq/goal"/>
  <remap from="/tags/feedback" to="/kinton_tag_selector/tagseq/feedback"/>
  <remap from="/tags/result" to="/kinton_tag_selector/tagseq/result"/>
  <remap from="/tags/cancel" to="/kinton_tag_selector/tagseq/cancel"/>
  <remap from="/tags/status" to="/kinton_tag_selector/tagseq/status"/>   
</node>
-->


<!-- _________ Task priority control _________-->
<!--<node pkg="kinton_arm_task_priority_control" type="kinton_arm_task_priority_control" name="kinton_arm_task_priority_control" output="screen">
  <remap from="~cam_vel"          to="/iri_artag_ibvs/cmd_vel_cov"/>
  <remap from="~input_tag"        to="/kinton_tag_selector/output_tag"/>
  <remap from="~pose"             to="/kinton/pose"/> 
  <remap from="~joint_traj"       to="/$(arg robot_id)/joint_traj"/>
  <remap from="~joint_states"     to="/$(arg robot_id)/joint_states"/>
  <remap from="/waypoints/goal" to="/kinton_autonomy/input_waypoints/goal"/>
  <remap from="/waypoints/feedback" to="/kinton_autonomy/input_waypoints/feedback"/>
  <remap from="/waypoints/result" to="/kinton_autonomy/input_waypoints/result"/>
  <remap from="/waypoints/cancel" to="/kinton_autonomy/input_waypoints/cancel"/>
  <remap from="/waypoints/status" to="/kinton_autonomy/input_waypoints/status"/>    
  <param name="arm_unina"         type="bool"   value="$(arg kinton_arm_unina_)"/>
  <param name="arm_catec"         type="bool"   value="$(arg kinton_arm_catec_)"/>
  <param name="arm_iri"           type="bool"   value="$(arg kinton_arm_iri_)"/>
  <param name="quad_x_ini"        type="double" value="$(arg quad_x_ini_)"/>    
  <param name="quad_y_ini"        type="double" value="$(arg quad_y_ini_)"/>    
  <param name="quad_z_ini"        type="double" value="$(arg quad_z_ini_)"/>    
  <param name="quad_roll_ini"     type="double" value="$(arg quad_R_ini_)"/>    
  <param name="quad_pitch_ini"    type="double" value="$(arg quad_P_ini_)"/>    
  <param name="quad_yaw_ini"      type="double" value="$(arg quad_Y_ini_)"/>  
  <param name="write_files"       type="bool"   value="$(arg write_files_)"/>   
  <param name="folder_name"       type="string" value="$(arg folder_name_)"/>     
  <param name="des_x"             type="double" value="$(arg desired_x)"/>
  <param name="des_y"             type="double" value="$(arg desired_y)"/>
  <param name="des_z"             type="double" value="$(arg desired_z)"/>
  <param name="des2_x"            type="double" value="$(arg desired2_x)"/>
  <param name="des2_y"            type="double" value="$(arg desired2_y)"/>
  <param name="des2_z"            type="double" value="$(arg desired2_z)"/>  
  <param name="robot_prefix"      type="string" value="kinton"/>
  <param name="marker_id"         type="string" value="/0"/>
  <param name="lambda_quadrotor"  type="double" value="1"/>
  <param name="lambda_arm"        type="double" value="1"/>  
  <param name="W_alpha_min"       type="double" value="$(arg W_alpha_min_)"/>
  <param name="W_min"             type="double" value="$(arg W_min_)"/>
  <param name="W_max"             type="double" value="$(arg W_max_)"/>
  <param name="Inf_radius"          type="double" value="$(arg Inf_radius_)"/>
  <param name="enable_sec_task"   type="bool"   value="$(arg enable_sec_task_)"/>
  <param name="gain_sec_task_CoG" type="double" value="$(arg gain_sec_task_CoG_)"/>
  <param name="gain_sec_task_jntlim" type="double" value="$(arg gain_sec_task_jntlim_)"/>
  <param name="sat_enable"        type="bool"   value="$(arg sat_enable_)"/>
  <param name="sat_quad_linear"   type="double" value="$(arg sat_quad_linear_)"/>
  <param name="sat_quad_angular"  type="double" value="$(arg sat_quad_angular_)"/>
  <param name="sat_arm_joint_vel" type="double" value="$(arg sat_arm_joint_vel_)"/>
  <param name="arm_q1_ini"        type="double" value="$(arg arm_q1_ini_)"/>    
  <param name="arm_q2_ini"        type="double" value="$(arg arm_q2_ini_)"/>    
  <param name="arm_q3_ini"        type="double" value="$(arg arm_q3_ini_)"/>    
  <param name="arm_q4_ini"        type="double" value="$(arg arm_q4_ini_)"/>    
  <param name="arm_q5_ini"        type="double" value="$(arg arm_q5_ini_)"/>  
  <param name="arm_q6_ini"        type="double" value="$(arg arm_q6_ini_)"/>  
  <param name="third_task_q1"     type="double" value="$(arg third_task_q1_)"/>    
  <param name="third_task_q2"     type="double" value="$(arg third_task_q2_)"/>    
  <param name="third_task_q3"     type="double" value="$(arg third_task_q3_)"/>    
  <param name="third_task_q4"     type="double" value="$(arg third_task_q4_)"/>    
  <param name="third_task_q5"     type="double" value="$(arg third_task_q5_)"/>      
</node>
-->
</launch>
